



function Initialize(Plugin)
	PLUGIN = Plugin;
	BlockEveryone = false
	BlockPlayer = {}
	Plugin:SetName("BlockBlock");
	Plugin:SetVersion(1);
	
	PluginManager = cRoot:Get():GetPluginManager();
	PluginManager:AddHook(Plugin, cPluginManager.HOOK_PLAYER_PLACING_BLOCK)
	PluginManager:AddHook(Plugin, cPluginManager.HOOK_PLAYER_USED_ITEM)
	PluginManager:AddHook(Plugin, cPluginManager.HOOK_PLAYER_USING_ITEM)

	PluginManager:BindCommand("/blockblock",    "BlockBlock.Block",         HandleBlockCommand,         " - Block the block placement of a player");
	PluginManager:BindCommand("/bb",            "BlockBlock.Block",         HandleBlockCommand,         "");
	LoadSettings()
	LOG("Initialized " .. PLUGIN:GetName() .. " v" .. PLUGIN:GetVersion())
	return true;
end

function LoadSettings()
	Settings = cIniFile(PLUGIN:GetLocalDirectory() .."/Config.ini")
	Settings:ReadFile()
	BlockWater = Settings:GetValueSet("Block", "Water", "false")
	BlockLava = Settings:GetValueSet("Block", "Lava", "true")
	BlockFire = Settings:GetValueSet("Block", "Fire", "true")
	BlockTNT = Settings:GetValueSet("Block", "TNT", "true")
	BlockMobs = Settings:GetValueSet("Block", "Mobs", "true")
	Settings:WriteFile()
end

function HandleBlockCommand( Split, Player )
	if Split[2] == nil then
		if BlockEveryone == true then
			BlockEveryone = false
			Player:SendMessage(cChatColor.Green .. "Everyone is unblocked")
		elseif BlockEveryone == false then
			BlockEveryone = true
			Player:SendMessage(cChatColor.Rose .. "Everyone is blocked")
		end
	else
		if BlockPlayer[Split[2]] == nil then
			BlockPlayer[Split[2]] = true
			Player:SendMessage(cChatColor.Rose .. "Player " .. Split[2] .. " is blocked")
		elseif BlockPlayer[Split[2]] == true then
			BlockPlayer[Split[2]] = false
			Player:SendMessage(cChatColor.Green .. "Player " .. Split[2] .. " is unblocked")
		elseif BlockPlayer[Split[2]] == false then
			BlockPlayer[Split[2]] = true
			Player:SendMessage(cChatColor.Rose .. "Player " .. Split[2] .. " is blocked")
		end
	end
	return true
end

function OnPlayerPlacingBlock(Player, BlockX, BlockY, BlockZ, BlockFace, BlockType, BlockMeta)
	if BlockEveryone == true then
		Player:SendMessage(cChatColor.Red .. "You cannot build now")
		return true
	end
	if BlockPlayer[Player:GetName()] == true then
		Player:SendMessage(cChatColor.Red .. "You cannot build now")
		return true
	end
	if (Player:HasPermission("BlockBlock.Bypass")) then
		return false
	else
		if BlockTNT == "true" then
			if (Player:GetEquippedItem().m_ItemType == E_BLOCK_TNT) then
				Player:SendMessage(cChatColor.Red .. "You may not place that")
				return true
			end
		end
	end
end

function OnPlayerUsedItem(Player, BlockX, BlockY, BlockZ, BlockFace, BlockType, BlockMeta)
	if BlockX == -1 and BlockY == 255 and BlockZ == -1 then
		return true
	end
	if BlockEveryone == true then
		Player:SendMessage(cChatColor.Red .. "You cannot build now")
		return true
	end
	if BlockPlayer[Player:GetName()] == true then
		Player:SendMessage(cChatColor.Red .. "You cannot build now")
		return true
	end
	if (Player:HasPermission("BlockBlock.Bypass")) then
		return false
	else
		World = Player:GetWorld()
		if BlockLava == "true" then
			if (Player:GetEquippedItem().m_ItemType == E_ITEM_LAVA_BUCKET) or (Player:GetEquippedItem().m_ItemType == E_BLOCK_STATIONARY_LAVA) then
				Player:SendMessage(cChatColor.Red .. "You may not place that")
				PlaceAir(World, BlockX, BlockY, BlockZ, BlockFace)
				return true
			end
		end
		if BlockFire == "true" then
			if (Player:GetEquippedItem().m_ItemType == E_ITEM_FLINT_AND_STEEL) or (Player:GetEquippedItem().m_ItemType == E_BLOCK_FIRE) then
				Player:SendMessage(cChatColor.Red .. "You may not place that")
				PlaceAir(World, BlockX, BlockY, BlockZ, BlockFace)
				return true
			end
		end
		if BlockWater == "true" then
			if (Player:GetEquippedItem().m_ItemType == E_ITEM_WATER_BUCKET) or (Player:GetEquippedItem().m_ItemType == E_BLOCK_WATER) or (Player:GetEquippedItem().m_ItemType == E_BLOCK_STATIONARY_WATER) then
				Player:SendMessage(cChatColor.Red .. "You may not place that")
				PlaceAir(World, BlockX, BlockY, BlockZ, BlockFace)
				return true
			end
		end
	end
end

function OnPlayerUsingItem(Player, BlockX, BlockY, BlockZ, BlockFace, BlockType, BlockMeta)
	if BlockX == -1 and BlockY == 255 and BlockZ == -1 then
		return true
	end
	if BlockEveryone == true then
		Player:SendMessage(cChatColor.Red .. "You cannot build now")
		return true
	end
	if BlockPlayer[Player:GetName()] == true then
		Player:SendMessage(cChatColor.Red .. "You cannot build now")
		return true
	end
	if (Player:HasPermission("BlockBlock.Bypass")) then
		return false
	else
		if BlockMobs == "true" then
			if (Player:GetEquippedItem().m_ItemType == 383) then
				Player:SendMessage(cChatColor.Red .. "You may not place that")
				return true
			end
		end
	end
end

function PlaceAir(World, BlockX, BlockY, BlockZ, BlockFace)
	if BlockFace == 0 then
		BlockY = BlockY - 1
	elseif BlockFace == 1 then
		BlockY = BlockY + 1
	elseif BlockFace == 2 then
		BlockZ = BlockZ - 1
	elseif BlockFace == 3 then
		BlockZ = BlockZ + 1
	elseif BlockFace == 4 then
		BlockX = BlockX - 1
	elseif BlockFace == 5 then
		BlockX = BlockX + 1
	end
	World:SetBlock(BlockX, BlockY, BlockZ, 0, 0)
end