-- Global variables
PLUGIN = {}	-- Reference to own plugin object

-- WORLD
WORK_WORLD = cRoot:Get():GetDefaultWorld():GetName()
WW_instance = cRoot:Get():GetDefaultWorld()

function Initialize(Plugin)
	PLUGIN = Plugin
	
	PLUGIN:SetName("Rainy")
	PLUGIN:SetVersion(3)
	
	PluginManager = cRoot:Get():GetPluginManager()
	PluginManager:BindCommand("/weather", "Rainy.weather", HandleWeatherCommand, " - [Sun/Rain] - Sets the weather");
	
	Plugin:AddWebTab("Time and Weather", HandleRequest_Rainy)
	
	WW_instance = cRoot:Get():GetWorld(WORK_WORLD)
	if (WW_instance == nil) then
		LOG(""..PLUGIN:GetName().." v."..PLUGIN:GetVersion()..": NO WORLD found :(")
	end
	
	LOG("Initialized "..PLUGIN:GetName().." v"..PLUGIN:GetVersion())
	return true
end

function OnDisable()
	LOG(PLUGIN:GetName() .. " v" .. PLUGIN:GetVersion() .. " is shutting down...")
end

function HandleWeatherCommand(Split, Player)
	if( #Split ~= 2 ) then
		Player:SendMessage( cChatColor.Green .. "Usage: /weather [Sun/Rain]" )
		return true;
	end

	local Server = cRoot:Get():GetServer()
	if( string.upper( Split[2] ) == "SUN") then
		Player:GetWorld():SetWeather(0)
		Server:SendMessage( cChatColor.Green .. Player:GetName() .. " set the weather to Sun.")
	elseif( string.upper( Split[2] ) == "RAIN") then
		Player:GetWorld():SetWeather(1)
		Server:SendMessage( cChatColor.Green .. Player:GetName() .. " set the weather to Rain.")
	else
		Player:SendMessage( cChatColor.Green .. "Usage: /weather [Sun/Rain]" )
	end
	return true
end